#include "register_types.h"
#include "utils/game_mode.hpp"
#include "utils/game_root.hpp"
#include "utils/game_state.hpp"
#include "utils/level.hpp"
#include "utils/player_input.hpp"
#include "utils/spawn_point.hpp"
#include <gdextension_interface.h>
#include <godot_cpp/core/class_db.hpp>
#include <godot_cpp/core/defs.hpp>
#include <godot_cpp/godot.hpp>

using namespace godot;

void initialize_gdextension_types(ModuleInitializationLevel p_level)
{
    if (p_level != MODULE_INITIALIZATION_LEVEL_SCENE) {
        return;
    }
    ClassDB::register_class<GameMode>();
    ClassDB::register_class<GameRoot3D>();
    ClassDB::register_class<GameState>();
    ClassDB::register_class<Level3D>();
    ClassDB::register_class<PlayerInput>();
    ClassDB::register_class<SpawnPoint3D>();

}

extern "C"
{
    // Initialization
    GDExtensionBool GDE_EXPORT dirt_racer_library_init(GDExtensionInterfaceGetProcAddress p_get_proc_address, GDExtensionClassLibraryPtr p_library, GDExtensionInitialization *r_initialization)
    {
        GDExtensionBinding::InitObject init_obj(p_get_proc_address, p_library, r_initialization);
        init_obj.register_initializer(initialize_gdextension_types);
        init_obj.set_minimum_library_initialization_level(MODULE_INITIALIZATION_LEVEL_SCENE);

        return init_obj.init();
    }
}
